Subject: Re: [Security, resend] Instant crash with rtl8169 and large packets

From: Michael Tokarev <[email-masked]>
Date: Mon, 08 Jun 2009 23:28:54 +0400

Eric Dumazet wrote:
> OK I suspect driver is buggy since 2.6.10 days :)

I browsed the git history for a while but don't see since
when it might be broken.  But again, I don't know the code
nor the hardware.

> Could you try this patch ?

That makes quite some sense, except of two comments - pure
speculation/guesses really, since I don't know the hw.

The patch does not re-program the card when we change MTU
(where we merely set internal rx_buf_sz, but don't tell the
card about this).  Maybe we should call this method in
rtl8169_set_rxbufsize() too?

I don't know almost anything about things like vlans for
example, but guess they use some additional headers.  Does
those need some space too?  Maybe its better to allocate
"a bit" more room in skb for that stuff?

Recompiling the driver now...

/mjt